#include <iostream>
#include <atomic>
#include <thread>

std::atomic<int> counter(0);  // Atomic integer

void increment() {
    for (int i = 0; i < 1000; ++i) {
        ++counter;  // Atomic increment
    }
}

int main() {
    std::thread t1(increment);
    std::thread t2(increment);

    t1.join();
    t2.join();

    std::cout << "Final counter value: " << counter << std::endl;  // Should be 2000

    return 0;
}

